=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2011-09-06 11:01:30 +0000
+++ bzrlib/builtins.py	2011-09-06 13:35:07 +0000
@@ -5662,7 +5662,10 @@
                 note('Tag %s already exists for that revision.' % tag_name)
             else:
                 branch.tags.set_tag(tag_name, revision_id)
-                note('Created tag %s.' % tag_name)
+                if existing_target is None:
+                    note('Created tag %s.' % tag_name)
+                else:
+                    note('Updated tag %s.' % tag_name)
 
 
 class cmd_tags(Command):

=== modified file 'bzrlib/tests/blackbox/test_tags.py'
--- bzrlib/tests/blackbox/test_tags.py	2011-08-31 15:25:11 +0000
+++ bzrlib/tests/blackbox/test_tags.py	2011-09-06 10:07:53 +0000
@@ -77,7 +77,8 @@
         out, err = self.run_bzr('tag -d branch NEWTAG -r0', retcode=3)
         self.assertContainsRe(err, 'Tag NEWTAG already exists\\.')
         # ... but can if you use --force
-        out, err = self.run_bzr('tag -d branch NEWTAG --force')
+        out, err = self.run_bzr('tag -d branch NEWTAG --force -r0')
+        self.assertEquals("Updated tag NEWTAG.\n", err)
 
     def test_tag_same_revision(self):
         t = self.make_branch_and_tree('branch')

=== modified file 'doc/en/release-notes/bzr-2.5.txt'
--- doc/en/release-notes/bzr-2.5.txt	2011-09-06 10:11:54 +0000
+++ doc/en/release-notes/bzr-2.5.txt	2011-09-06 13:35:07 +0000
@@ -106,7 +106,8 @@
   (Jelmer Vernooij, #164450)
 
 * ``bzr tag`` no longer errors if a tag already exists but refers to the
-  same revision. (Jelmer Vernooij)
+  same revision, and will mention when a tag has been updated
+  rather than created. (Jelmer Vernooij, #381203)
 
 * ``bzr uncommit`` will now remove tags that refer to removed revisions.
   The ``--keep-tags`` option can be used to prevent this behaviour.

